"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var BroccoliPlugin = require("broccoli-plugin");
var path = require("path");
var fs = require("fs-extra");
/* eslint-disable-next-line @typescript-eslint/no-var-requires */
var ensureSymlink = require("ensure-symlink");
/**
 * Creates symlinks to the source files specified.
 *
 *  BroccoliSymbolicLinker
 */
var BroccoliSymbolicLinker = /** @class */ (function (_super) {
    __extends(BroccoliSymbolicLinker, _super);
    function BroccoliSymbolicLinker(fileMap, options) {
        if (options === void 0) { options = {}; }
        var _this = this;
        var pluginOpts = { needsCache: false };
        Object.assign(pluginOpts, options);
        _this = _super.call(this, [], pluginOpts) || this;
        _this.files = Object.assign({}, fileMap);
        return _this;
    }
    BroccoliSymbolicLinker.prototype.reset = function (fileMap) {
        this.files = Object.assign({}, fileMap);
    };
    /**
     * Record that a symlink should be created from src to dest.
     *
     * This can be called many times before the build method is invoked.
     * Calling it after will not have an effect until the next time build() is
     * invoked.
     *
     * @param src The file that should be symlinked into the tree.
     * @param dest the relative path from the tree's root to the location of the
     *   symlink. the filename does not have to be the same.
     * @returns the absolute path to the location where the symlink will be created.
     */
    // eslint-disable-next-line @typescript-eslint/camelcase
    BroccoliSymbolicLinker.prototype.ln_s = function (src, dest) {
        this.files[dest] = src;
        return path.join(this.outputPath, dest);
    };
    /**
     * Returns the number of symlinks that will be created.
     */
    BroccoliSymbolicLinker.prototype.numberOfFiles = function () {
        return Object.keys(this.files).length;
    };
    /**
     * Create the symlinks. Directories to them will be created as necessary.
     */
    BroccoliSymbolicLinker.prototype.build = function () {
        var e_1, _a;
        try {
            // eslint-disable-next-line no-console
            // console.log(`Building ${this.numberOfFiles()} symlinks for ${this["_annotation"]}.`);
            for (var _b = __values(Object.keys(this.files)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var dest = _c.value;
                var src = this.files[dest];
                // console.log(`linking ${src} to ${dest}`);
                dest = path.join(this.outputPath, dest);
                var dir = path.dirname(dest);
                fs.mkdirpSync(dir);
                ensureSymlink(src, dest);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * Output the symlinks that will be created for debugging.
     */
    BroccoliSymbolicLinker.prototype.debug = function () {
        return Object.keys(this.files).join("\n");
    };
    return BroccoliSymbolicLinker;
}(BroccoliPlugin));
exports.BroccoliSymbolicLinker = BroccoliSymbolicLinker;
//# sourceMappingURL=broccoli-ln-s.js.map